VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmGrafici 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Grafici"
   ClientHeight    =   5160
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8895
   Icon            =   "frmGrafici.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   5160
   ScaleWidth      =   8895
   Begin MSComctlLib.Slider sldViMax 
      Height          =   255
      Left            =   780
      TabIndex        =   7
      Top             =   4860
      Width           =   2115
      _ExtentX        =   3731
      _ExtentY        =   450
      _Version        =   393216
      MousePointer    =   99
      MouseIcon       =   "frmGrafici.frx":0442
      LargeChange     =   1
      Min             =   1
      Max             =   32
      SelStart        =   1
      TickFrequency   =   4
      Value           =   1
   End
   Begin VB.TextBox txtCarSpettro 
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5880
      MaxLength       =   1
      TabIndex        =   4
      Top             =   4860
      Width           =   375
   End
   Begin VB.CommandButton cmdBlocca 
      Caption         =   "&Blocca"
      Height          =   255
      Left            =   7830
      TabIndex        =   5
      Top             =   4860
      Width           =   915
   End
   Begin VB.PictureBox picSpettro 
      BackColor       =   &H005B5B2F&
      Height          =   1740
      Left            =   120
      MousePointer    =   2  'Cross
      ScaleHeight     =   1680
      ScaleWidth      =   8595
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3000
      Width           =   8655
   End
   Begin VB.PictureBox picSegnale 
      BackColor       =   &H005B5B2F&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFF00&
      Height          =   2835
      Left            =   120
      MousePointer    =   2  'Cross
      ScaleHeight     =   2775
      ScaleWidth      =   8595
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Width           =   8655
   End
   Begin VB.Label lblViMax 
      BackStyle       =   0  'Transparent
      Caption         =   "???"
      Height          =   255
      Left            =   2940
      TabIndex        =   6
      Top             =   4875
      Width           =   735
   End
   Begin VB.Label lblSoglia 
      BackStyle       =   0  'Transparent
      Caption         =   "&Vi Max:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   4875
      Width           =   555
   End
   Begin VB.Label lblCarSpettro 
      BackStyle       =   0  'Transparent
      Caption         =   "Spettro del &carattere:"
      Height          =   255
      Left            =   4320
      TabIndex        =   3
      Top             =   4875
      Width           =   1575
   End
End
Attribute VB_Name = "frmGrafici"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=======================================================================================
' Descrizione.....: Form per il grafico di toni audio.
' Nome dei Files..: frmGrafici.frm, frmGrafici.frx,
'                   modDecoToni.bas, modUtilita.bas
' Data............: 19/03/2004
' Versione........: 1.0 a 32 bits
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
Private CharY!                      ' Posizione verticale dei caratteri della sequenza.
Private SxMax!, SyMin!, SyMax!      ' Limiti delle scale del quadro segnali.
'
Private Const ColRet& = &HAFAFAF    ' Colore dei reticoli.
Private Const ColSch& = &H5B5B2F    ' Colore di fondo degli schermi.

Public Sub Apri(Optional ByVal NcRX_I As Long)
'
'
    sldViMax.Value = Int(ViMax / 1000!)
'
    ImpostaQuadri
'
    Me.ZOrder vbSendToBack
'
'
'
End Sub
Private Sub cmdBlocca_Click()
'
'
    bDisegnaGrafici = (Not bDisegnaGrafici)
    cmdBlocca.Caption = IIf(bDisegnaGrafici, "&Blocca", "&Disegna")
'
'
'
End Sub
Private Sub Form_Load()
'
'
    Dim Me_L&, Me_T&, ITr&, lRet&
'
    LeggiPosizioneFormINI FileINI$, Me, Me_L, Me_T
    Me.Move Me_L, Me_T
'
    txtCarSpettro.Text = "0"
'
    CloseButtonDisable Me
'
    bDisegnaGrafici = True
'
'
'
End Sub
Public Sub DisegnaSegnale_SSC(ByVal NVin As Long, VIn() As Single, _
    ByVal NChar As Long, PosChar() As Long, Char$())
'
'   Visualizza il segnale della sequenza.
'   Routine opzionale:
'
    Dim I&, I1&
'
    picSegnale.Cls
    picSegnale.DrawWidth = 1
'
    ' Disegno il segnale:
    picSegnale.PSet (1, VIn(1)), vbYellow
    For I = 2 To NVin
        picSegnale.Line -(I, VIn(I)), vbYellow
    Next I
'
    If (Not bSSC_NS) Then
        ' Disegno il livello di soglia:
        picSegnale.Line (0, SogliaSigRMS)-(SxMax, SogliaSigRMS), vbGreen
    End If
'
    picSegnale.CurrentY = CharY
    For I = 1 To NChar
        ' Scrivo il corrispondente carattere
        ' eventualmente decodificato:
        picSegnale.CurrentX = PosChar(I)
        picSegnale.Print Char$(I);
    Next I
'
'
'
End Sub
Public Sub DisegnaSegnale_SPM(ByVal NVin As Long, VIn() As Single, _
    ByVal NChar As Long, PosChar() As Long, Char$(), ByVal Ib As Long)
'
'   Visualizza il segnale della sequenza.
'   Routine opzionale:
'
    Dim I&, I1&
'
    picSegnale.Cls
    picSegnale.DrawWidth = 1
'
    ' Disegno il segnale:
    picSegnale.PSet (1, VIn(1)), vbYellow
    For I = 2 To NVin
        picSegnale.Line -(I, VIn(I)), vbYellow
    Next I
'
    ' Livello di trigger sotto il quale si e' in pausa:
    picSegnale.Line (0, TrigLivMin)-(SxMax, TrigLivMin), vbBlue
    ' Livello di trigger sopra il quale c' e' segnale:
    picSegnale.Line (0, TrigLivMax)-(SxMax, TrigLivMax), vbCyan
'
    ' Disegno la divisione fra i blocchi
    ' dei dati acquisiti:
    picSegnale.Line (Ib, SyMin)-(Ib, SyMax), vbMagenta
'
    picSegnale.CurrentY = CharY
    For I = 1 To NChar
        ' Scrivo il corrispondente carattere
        ' eventualmente decodificato:
        picSegnale.CurrentX = PosChar(I)
        picSegnale.Print Char$(I);
    Next I
'
'
'
End Sub
Public Sub DisegnaSegnale_DFT(ByVal NVin As Long, VIn() As Single, Char$(), ByVal Ib As Long)
'
'   Visualizza il segnale della sequenza.
'   Routine opzionale:
'
    Dim I&, I1&
'
    picSegnale.Cls
    picSegnale.DrawWidth = 1
'
    ' Disegno il segnale:
    picSegnale.PSet (1, VIn(1)), vbYellow
    For I = 2 To NVin
        picSegnale.Line -(I, VIn(I)), vbYellow
    Next I
'
    ' Livello di soglia:
    picSegnale.Line (0, SogliaSigRMS)-(SxMax, SogliaSigRMS), vbGreen
    ' Livello di trigger sotto il quale si e' in pausa:
    picSegnale.Line (0, TrigLivMin)-(SxMax, TrigLivMin), vbBlue
    ' Livello di trigger sopra il quale c' e' segnale:
    picSegnale.Line (0, TrigLivMax)-(SxMax, TrigLivMax), vbCyan
'
    ' Disegno la divisione fra i blocchi
    ' dei dati acquisiti:
    picSegnale.Line (Ib, SyMin)-(Ib, SyMax), vbMagenta
'
    I1 = 0
    picSegnale.DrawWidth = 3
    For I = NcOff To MIN0(NcSeqRX, NVin) Step NcToneRX
        ' Segno la parte selezionata del segnale:
        picSegnale.Line (I, 0)-(I + NcFT, 0), vbRed
'
        ' e scrivo il corrispondente carattere
        ' eventualmente decodificato:
        I1 = I1 + 1
        picSegnale.CurrentX = I
        picSegnale.CurrentY = CharY
        picSegnale.Print Char$(I1);
    Next I
'
'
'
End Sub
Private Sub Form_Unload(Cancel As Integer)
'
'
    SalvaPosizioneFormINI FileINI$, Me
'
    Set frmGrafici = Nothing
'
'
'
End Sub
Public Sub DisegnaSpettro_DFT(ByVal NFreq As Long, Freq() As Double, SSp() As Double)
'
'   Visualizza lo spettro completo di
'   un carattere della sequenza.
'   Routine opzionale:
'
    Dim I&
'
    picSpettro.Cls
'
    For I = 0 To NFreq - 1
        picSpettro.Line (Freq(I), 0)-(Freq(I), SSp(I)), vbYellow
    Next I
'
'
'
End Sub
Private Sub sldViMax_Change()
'
'
    ViMax = sldViMax.Value * 1000!
    lblViMax = ViMax
    ImpostaQuadri
'
'
'
End Sub
Private Sub picSegnale_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    picSegnale.ToolTipText = " " & Format$(X, "#0") & ",  " & Format$(Y, "#0") & " "
'
'
'
End Sub

Private Sub picSpettro_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    picSpettro.ToolTipText = " " & Format$(X, "#0.0") & ",  " & Format$(Y, "#0") _
                           & IIf(FreqToCode(X) <> "", "  """ & FreqToCode(X) & """ ", " ")
'
'
'
End Sub
Private Sub txtCarSpettro_Change()
'
'
    CarSpettro$ = txtCarSpettro.Text
    ICarSpettro = CodeToInd(CarSpettro)
'
'
'
End Sub
Private Sub txtCarSpettro_KeyPress(KeyAscii As Integer)
'
'
    KeyAscii = Asc(UCase$(Chr$(KeyAscii)))
    KeyAscii = KAscVetC(KeyAscii, ToneChar$())
'
'
'
End Sub
Private Sub ImpostaQuadri()
'
'   Prepara i quadri dei grafici:
'
    Dim I&, SSyMax!, FMin#, FMax#
'
    ' Per segnale:
    picSegnale.Height = IIf(DecM = DecDFT, 2835, 4680)
'
    Quadro picSegnale, 0#, -ViMax, CDbl(NcRX), ViMax, , , , , , , , _
           "Segnale", "Nc", "Vi", , , , , SyMin, SxMax, SyMax, , , , , _
           ColRet, ColSch
    CharY = SyMax / 4
'
    If (DecM = DecDFT) Or ((DecM = DecSSC) And (Not bSSC_NS)) Then
        ' Disegno il livello di soglia:
        picSegnale.Line (0, SogliaSigRMS)-(SxMax, SogliaSigRMS), vbGreen
    End If
'
    If (DecM <> DecSSC) Then
        ' Disegno il livello di trigger sotto il quale si e' in pausa ...:
        picSegnale.Line (0, TrigLivMin)-(SxMax, TrigLivMin), vbBlue
        ' ... e quello sopra il quale c' e' segnale:
        picSegnale.Line (0, TrigLivMax)-(SxMax, TrigLivMax), vbCyan
    End If
'
    ScrivoCome picSegnale, "MS Sans Serif", 8, True, vbRed
    picSegnale.AutoRedraw = False
'
    ' Per spettri:
    If (DecM = DecDFT) Then
        picSpettro.Visible = True
'
        FMin = TnFMin * (1 - TolFreqTX / 100)
        FMax = TnFMax * (1 + TolFreqTX / 100)
        Quadro picSpettro, FMin, 0, FMax, ViMax, , , , , , , , _
               "Spettri", "Hz", "Vi", True, , , , , , SSyMax, , , , , _
               ColRet, ColSch
'
        ' Disegno i limiti min. e Max. delle frequenze tonali:
        For I = 0 To NTonesDec - 1
            picSpettro.Line (DeltaFreq(1, I), 0)-(DeltaFreq(2, I), 1.05 * SSyMax), _
                            vbMagenta, B
        Next I
'
        picSpettro.DrawWidth = 3
        picSpettro.AutoRedraw = False
'
    Else
        picSpettro.Visible = False
    End If
'
'
'
End Sub
Public Sub DisegnaSpettroMobile(ByVal Nv As Long, vSPM() As Double, VMed() As Double)
'
'
    Dim I&
'
    ' Disegno lo spettro mobile:
    picSegnale.PSet (1, vSPM(1)), vbMagenta
    For I = 2 To Nv
        picSegnale.Line -(I, vSPM(I)), vbMagenta
    Next I
'
    ' Disegno il valor medio:
    picSegnale.PSet (1, VMed(1)), vbRed
    For I = 2 To Nv
        picSegnale.Line -(I, VMed(I)), vbRed
    Next I
'
'
'
End Sub
